Index: Source/Fortran/makefile_fast
===================================================================
--- Source/Fortran/makefile_fast	(revision d2d6cf918895f938ac0288f15d1b1032d4323b03)
+++ Source/Fortran/makefile_fast	(revision 14d96186895955cf5ee8d4076dafba8ab936bff6)
@@ -19,10 +19,11 @@
 LIB =  $(ECCODES_LIB) $(EMOSLIB)
 
-ECCODES_INCLUDE_DIR=/usr/local/include/
-#/usr/lib/x86_64-linux-gnu/fortran/gfortran-mod-15
+ECCODES_INCLUDE_DIR=/usr/lib/x86_64-linux-gnu/fortran/gfortran-mod-15
+#/usr/local/include/ #oldstable
+
 INC = -I. -I$(ECCODES_INCLUDE_DIR)
 
 FC = gfortran 
-OPT = -O3 -march=native
+OPT = -O3 # -O3 -march=native
 FFLAGS =   $(OPT) $(LIB) $(INC) -fdefault-real-8 -fopenmp -fconvert=big-endian 
 LDFLAGS =  $(OPT) $(LIB) -fopenmp
Index: Testing/Regression/FortranEtadot/run_ref.sh
===================================================================
--- Testing/Regression/FortranEtadot/run_ref.sh	(revision d2d6cf918895f938ac0288f15d1b1032d4323b03)
+++ Testing/Regression/FortranEtadot/run_ref.sh	(revision 14d96186895955cf5ee8d4076dafba8ab936bff6)
@@ -14,4 +14,5 @@
 exefast=calc_etadot_fast.out
 hash=$(git log --abbrev-commit --pretty=oneline -n 1  --pretty=format:'%h')
+csvfile='runtimes_'${HOST}'.csv'
 exitonfail=true
 rm -f log.run_ref failed
@@ -52,5 +53,5 @@
       if [ "${exitonfail}" = true ]; then exit; fi
     fi
-    for outfile in 'fort.15' 'VERTICAL.EC'; do
+    for outfile in 'fort.15' ; do
       if [ -e $outfile ]; then
         mv ${outfile} ../${outdir}
@@ -69,9 +70,9 @@
   # compare debug and fast
   # omega case also produces fort.25 - need to add this
-  for outfile in 'fort.15' 'VERTICAL.EC'; do
+  for outfile in 'fort.15' ; do
     outdebug='Outputs/Output_ref_'${ref}'_debug/'$outfile
     outfast='Outputs/Output_ref_'${ref}'_fast/'$outfile
-    test=$(cmp  $outdebug $outfast)
-    if $test; then
+    test=$()
+    if cmp -s $outdebug $outfast >/dev/null; then
       echo $outfile '    equal for debug and fast' >> log.run_ref
     else
@@ -89,5 +90,5 @@
     user=$(echo $times | grep user | awk '{print $4}')
     sys=$( echo $times | grep sys  | awk '{print $6}')
-    echo $hash, "'"reference"'", "'"${ref}'_'${exe}"'", ${real}, ${user}, ${sys} >> runtimes.csv
+    echo $hash, "'"reference"'", "'"${ref}'_'${exe}"'", ${real}, ${user}, ${sys} >> ${csvfile}
     tail -1 runtimes.csv >> log.run_ref
   done
Index: Testing/Regression/FortranEtadot/run_regrtest.sh
===================================================================
--- Testing/Regression/FortranEtadot/run_regrtest.sh	(revision d2d6cf918895f938ac0288f15d1b1032d4323b03)
+++ Testing/Regression/FortranEtadot/run_regrtest.sh	(revision 14d96186895955cf5ee8d4076dafba8ab936bff6)
@@ -17,4 +17,5 @@
 exefast=calc_etadot_fast.out
 hash=$(git log --abbrev-commit --pretty=oneline -n 1  --pretty=format:'%h')
+csvfile='runtimes_'${HOST}'.csv'
 exitonfail=true
 numtest=0
@@ -84,9 +85,9 @@
     user=$(echo $times | grep user | awk '{print $4}')
     sys=$( echo $times | grep sys  | awk '{print $6}')
-    echo $hash, "'"reference"'", "'"${ref}'_'${exe}"'", ${real}, ${user}, ${sys} >> ../runtimes.csv
-    tail -1 ../runtimes.csv >> log.run_regr
+    echo $hash, "'"reference"'", "'"${ref}'_'${exe}"'", ${real}, ${user}, ${sys} >> ../${csvfile}
+    tail -1 ../${csvfile} >> log.run_regr
 
     cd ..
-    rm Work/* # this is for being more safe
+    rm -f Work/* # this is for being more safe
 
   done # end of exe loop
@@ -99,5 +100,5 @@
   | tee -a ../log.run_regr
 echo ' More information may be found in log.run_regr' 
-echo ' Runtimes were added to runtimes.csv under '$hash | tee -a ../log.run_regr
+echo ' Runtimes were added to '${csvfile}' under '$hash | tee -a ../log.run_regr
 
 # the following code is executed only if exitonfail is not set to 'true'.
Index: sting/Regression/FortranEtadot/runtimes.imp7
===================================================================
--- Testing/Regression/FortranEtadot/runtimes.imp7	(revision 2d1c338814a949a88dd9f5b55ddec4efbd7b60e6)
+++ 	(revision )
@@ -1,16 +1,0 @@
-949379e, 'reference', 'etadot_debug', 0m0.572s, 0m7.520s, 0m0.172s
-949379e, 'reference', 'etadot_fast', 0m0.550s, 0m6.740s, 0m0.236s
-949379e, 'reference', 'etadotall_debug', 0m0.729s, 0m7.280s, 0m0.168s
-949379e, 'reference', 'etadotall_fast', 0m0.675s, 0m6.568s, 0m0.148s
-949379e, 'reference', 'etadothigh_debug', 17m0.724s, 32m54.368s, 0m48.492s
-949379e, 'reference', 'etadothigh_fast', 15m50.120s, 26m22.308s, 0m42.076s
-949379e, 'reference', 'gauss_debug', 0m2.532s, 0m25.768s, 0m1.452s
-949379e, 'reference', 'gauss_fast', 0m1.996s, 0m16.732s, 0m0.900s
-949379e, 'reference', 'gaussall_debug', 0m7.884s, 1m21.248s, 0m1.852s
-949379e, 'reference', 'gaussall_fast', 0m5.914s, 0m42.856s, 0m2.356s
-949379e, 'reference', 'gausshigh_debug', 2m35.415s, 37m38.284s, 4m54.992s
-949379e, 'reference', 'gausshigh_fast', 2m10.102s, 23m22.540s, 5m51.612s
-949379e, 'reference', 'latlon_debug', 0m0.691s, 0m7.176s, 0m0.172s
-949379e, 'reference', 'latlon_fast', 0m0.673s, 0m7.032s, 0m0.152s
-949379e, 'reference', 'latlonall_debug', 0m0.777s, 0m6.772s, 0m0.620s
-949379e, 'reference', 'latlonall_fast', 0m0.687s, 0m7.064s, 0m0.196s
Index: Testing/Regression/FortranEtadot/runtimes_imp7.csv
===================================================================
--- Testing/Regression/FortranEtadot/runtimes_imp7.csv	(revision None)
+++ Testing/Regression/FortranEtadot/runtimes_imp7.csv	(revision None)
@@ -0,0 +1,32 @@
+949379e, 'reference', 'etadot_debug', 0m0.572s, 0m7.520s, 0m0.172s
+949379e, 'reference', 'etadot_fast', 0m0.550s, 0m6.740s, 0m0.236s
+949379e, 'reference', 'etadotall_debug', 0m0.729s, 0m7.280s, 0m0.168s
+949379e, 'reference', 'etadotall_fast', 0m0.675s, 0m6.568s, 0m0.148s
+949379e, 'reference', 'etadothigh_debug', 17m0.724s, 32m54.368s, 0m48.492s
+949379e, 'reference', 'etadothigh_fast', 15m50.120s, 26m22.308s, 0m42.076s
+949379e, 'reference', 'gauss_debug', 0m2.532s, 0m25.768s, 0m1.452s
+949379e, 'reference', 'gauss_fast', 0m1.996s, 0m16.732s, 0m0.900s
+949379e, 'reference', 'gaussall_debug', 0m7.884s, 1m21.248s, 0m1.852s
+949379e, 'reference', 'gaussall_fast', 0m5.914s, 0m42.856s, 0m2.356s
+949379e, 'reference', 'gausshigh_debug', 2m35.415s, 37m38.284s, 4m54.992s
+949379e, 'reference', 'gausshigh_fast', 2m10.102s, 23m22.540s, 5m51.612s
+949379e, 'reference', 'latlon_debug', 0m0.691s, 0m7.176s, 0m0.172s
+949379e, 'reference', 'latlon_fast', 0m0.673s, 0m7.032s, 0m0.152s
+949379e, 'reference', 'latlonall_debug', 0m0.777s, 0m6.772s, 0m0.620s
+949379e, 'reference', 'latlonall_fast', 0m0.687s, 0m7.064s, 0m0.196s
+d90a529, 'reference', 'etadot_debug', 0m0.504s, 0m0.431s, 0m0.016s
+d90a529, 'reference', 'etadot_fast', 0m0.442s, 0m0.529s, 0m0.017s
+d90a529, 'reference', 'etadotall_debug', 0m0.576s, 0m0.603s, 0m0.048s
+d90a529, 'reference', 'etadotall_fast', 0m0.604s, 0m0.673s, 0m0.028s
+d90a529, 'reference', 'etadothigh_debug', 17m14.011s, 16m31.983s, 0m18.441s
+d90a529, 'reference', 'etadothigh_fast', 17m23.426s, 16m31.624s, 0m21.645s
+d90a529, 'reference', 'gauss_debug', 0m3.348s, 0m7.130s, 0m0.208s
+d90a529, 'reference', 'gauss_fast', 0m2.403s, 0m5.028s, 0m0.156s
+d90a529, 'reference', 'gaussall_debug', 0m12.126s, 0m28.251s, 0m0.648s
+d90a529, 'reference', 'gaussall_fast', 0m9.868s, 0m23.323s, 0m0.880s
+d90a529, 'reference', 'gausshigh_debug', 5m4.089s, 14m23.018s, 0m12.998s
+d90a529, 'reference', 'gausshigh_fast', 4m48.049s, 13m11.227s, 0m16.318s
+d90a529, 'reference', 'latlon_debug', 0m0.657s, 0m0.681s, 0m0.016s
+d90a529, 'reference', 'latlon_fast', 0m0.485s, 0m0.563s, 0m0.004s
+d90a529, 'reference', 'latlonall_debug', 0m0.544s, 0m0.613s, 0m0.012s
+d90a529, 'reference', 'latlonall_fast', 0m0.534s, 0m0.620s, 0m0.020s